/// <reference types="react" />
import { BaseOptions, BasePaginatedOptions, BaseResult, CombineService, LoadMoreFormatReturn, LoadMoreOptions, LoadMoreOptionsWithFormat, LoadMoreParams, LoadMoreResult, OptionsWithFormat, PaginatedFormatReturn, PaginatedOptionsWithFormat, PaginatedParams, PaginatedResult } from './types';
import useAsync from './useAsync';
import useLoadMore from './useLoadMore';
import usePaginated from './usePaginated';
declare function useAPI<R = any, P extends any[] = any, U = any, UU extends U = any>(service: CombineService<R, P>, options: OptionsWithFormat<R, P, U, UU>): BaseResult<U, P>;
declare function useAPI<R = any, P extends any[] = any>(service: CombineService<R, P>, options?: BaseOptions<R, P>): BaseResult<R, P>;
declare function useAPI<R = any, Item = any, U extends Item = any>(service: CombineService<R, LoadMoreParams>, options: LoadMoreOptionsWithFormat<R, Item, U>): LoadMoreResult<Item>;
declare function useAPI<R = any, Item = any, U extends Item = any>(service: CombineService<LoadMoreFormatReturn<Item>, LoadMoreParams>, options: LoadMoreOptions<U>): LoadMoreResult<Item>;
declare function useAPI<R = any, Item = any, U extends Item = any>(service: CombineService<R, PaginatedParams<U>>, options: PaginatedOptionsWithFormat<R, Item, U>): PaginatedResult<Item>;
declare function useAPI<R = any, Item = any, U extends Item = any>(service: CombineService<PaginatedFormatReturn<Item>, PaginatedParams<U>>, options: BasePaginatedOptions<U>): PaginatedResult<Item>;
declare const UseAPIProvider: import("react").Provider<BaseOptions<any, any> | OptionsWithFormat<any, any, any, any> | BasePaginatedOptions<any> | LoadMoreOptions<any>>;
export { useAsync, usePaginated, useLoadMore, UseAPIProvider };
export default useAPI;
